//{$WARNINGS OFF}
//=============================================================================
//  Rg[̃hbOɂړ
//
//  hbOɃRg[̔摜\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ܂Czz̍ہCȂ闝R낤Ƃɑ㉿߂邱Ƃ֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2012N0410 `
//  2013N0421 R[h
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TControlDragObject = class(TDragControlObjectEx)
  private
    FDragImages: TDragImageList;
    FX : Integer;
    FY : Integer;
  protected
    function GetDragImages: TDragImageList; override;
  public
    constructor CreateStartPos(Control: TControl; X, Y: Integer);
    destructor Destroy; override;
  end;

  TForm1 = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1StartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure Image1EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure Image1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
  private
    { Private 錾 }
    ControlStartTop  : Integer;
    ControlStartLeft : Integer;
    FDragObject : TControlDragObject;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses TypInfo;

{$R *.dfm}

{ TControlDragObjectEx }

type
  TMyGraphicControl = class(TGraphicControl);

//-----------------------------------------------------------------------------
//  TDragControlObjectEx̐ƁChbOJnʒu̐ݒ
//  ̃\bh̖O͔C
//-----------------------------------------------------------------------------
constructor TControlDragObject.CreateStartPos(Control: TControl; X,
  Y: Integer);
begin
  inherited Create(Control);

  FX := X;
  FY := Y;
end;

//-----------------------------------------------------------------------------
//  TDragControlObjectExDestroy
//-----------------------------------------------------------------------------
destructor TControlDragObject.Destroy;
begin
  FDragImages.Free;

  inherited;
end;

//-----------------------------------------------------------------------------
//  TDragControlObjectExGetDragImages\bh
//
//  ŁCΏۃRg[̃rbg}bv쐬ēo^
//  ł̓Rg[̉摜rbg}bvƂĂ
//  rbg}bv𔼓̂TDragControlObjectExōs
//-----------------------------------------------------------------------------
function TControlDragObject.GetDragImages: TDragImageList;
var
  ABmp       : TBitmap;
  ImgIndex   : Integer;
  RectImg    : TRect;
  PropInfo   : PPropInfo;
  Background : Variant;
  ACanvas    : TCanvas;
begin
  if not Assigned(FDragImages) then FDragImages := TDragImageList.Create(nil);
  Result := FDragImages;
  Result.Clear;

  ABmp := TBitmap.Create;
  try
    ABmp.PixelFormat := pf32bit;
    ABmp.Width       := Control.Width;
    ABmp.Height      := Control.Height;

    ABmp.Canvas.Lock;
    try
      if Control is TWinControl then begin
        PropInfo := GetPropInfo((Control as TWinControl), 'ParentBackground');
        if PropInfo <> nil then begin
          Background := GetPropValue((Control as TWinControl), PropInfo);
          SetPropValue((Control as TWinControl), PropInfo, False);
        end;
        (Control as TWinControl).PaintTo(ABmp.Canvas.Handle, 0, 0);
        if PropInfo <> nil then begin
          SetPropValue((Control as TWinControl), PropInfo, Background);
        end;
      end else begin
        SetRect(RectImg, 0, 0, ABmp.Width, ABmp.Height);
        if Control is TImage then begin
          ABmp.Canvas.Brush.Color := clBtnFace;
          ABmp.Canvas.FillRect(RectImg);
          ABmp.Canvas.StretchDraw(RectImg, TImage(Control).Picture.Graphic);
        end else begin
          ACanvas := TMyGraphicControl(Control).Canvas;
          //BitBltł悢
          ABmp.Canvas.CopyRect(RectImg, ACanvas, RectImg);
        end;
      end;
    finally
      ABmp.Canvas.UnLock
    end;

    //쐬rbg}bṽTCY肵CDragImagesɒǉ
    if not ABmp.Empty then begin
      FDragImages.Width  := Control.Width;
      FDragImages.Height := Control.Height;

      ImgIndex := FDragImages.Add(ABmp, nil);
      FDragImages.SetDragImage(ImgIndex, FX, FY);
    end;
  finally
    ABmp.Free;
  end;
end;

//=============================================================================
//  tH[쐬̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);

  //---------------------------------------------------------------------------
  //  ̃Rg[ControlStylecsDisplayDragImageǉ
  //  ParentɊeRg[zuĂtH[w肷΁C̃tH[
  //  ̑SĂControlStylẽX^CύX邱ƂɂȂ
  //---------------------------------------------------------------------------
  procedure FixControlStyles(Parent: TControl);
  var
    i : Integer;
  begin
    Parent.ControlStyle := Parent.ControlStyle + [csDisplayDragImage];
    if Parent is TWinControl then begin
      with TWinControl(Parent) do begin
        for i := 0 to ControlCount - 1 do begin
          FixControlStyles(Controls[i]);
        end;
      end;
    end;
  end;
  //---------------------------------------------------------------------------

begin
  FixControlStyles(Self);
end;

//=============================================================================
//  Image1OnMouseDownCxg
//  ̃Rg[OnMouseDownCxgƋL
//
//  }EXDownhbOJn
//
//  DragMode = dmAutomatik
//    ̎́C̃}EXCxg͔ȂDŃhbNJnł
//    hbÕJ[\̓ftHgŕύXłȂ
//
//  DragMode = dmManual
//    ɂΔ邪Ĉ܂܂łOnDragOverCxgȂ
//    ŁCTControl(Sender).BeginDrag(True)s
//    hbÕJ[\́CDragCursorŎw肵`ƂȂ
//    ܂C낢ύXł
//=============================================================================
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then begin
    TControl(Sender).BeginDrag(True);
  end;
end;

//=============================================================================
//  Image1OnStartDragCxg
//  ̃Rg[OnStartDragCxgƋL
//
//  hbOJn̏
//=============================================================================
procedure TForm1.Image1StartDrag(Sender: TObject; var DragObject: TDragObject);
var
  Pt : TPoint;
begin
  GetCursorPos(Pt);

  ControlStartLeft := Pt.X;
  ControlStartTop  := Pt.Y;

  //TDragControlObjectExIuWFNg𐶐
  Pt := TControl(Sender).ScreenToClient(Pt);
  FDragObject := TControlDragObject.CreateStartPos(TControl(Sender), Pt.X, Pt.Y);
  //DragObjectɂɓn
  DragObject := FDragObject
end;

//=============================================================================
//  Image1OnDragOverCxg
//  ̃Rg[OnDragOverCxgƋL
//
//  hbȌ
//  ̃TvR[h̏ꍇCSourceTControlDragObjectExƂȂĂ
//=============================================================================
procedure TForm1.Image1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := True;
end;

//=============================================================================
//  Image1OnDragDropCxg
//  ̃Rg[OnDragDropCxgƋL
//  hbvʒuɃRg[`
//
//  hbOI
//  TDragControlObjectEx̏ꍇC̃IuWFNg̃CX^X̔j͕sv
//=============================================================================
procedure TForm1.Image1EndDrag(Sender, Target: TObject; X, Y: Integer);
var
  Pt : TPoint;
begin
  if Target = nil then exit;

  //Cxg̈X,Ygp鎞́CXN[Wlɕϊ
  GetCursorPos(Pt);

  TControl(Sender).Left := TControl(Sender).Left + (Pt.X - ControlStartLeft);
  TControl(Sender).Top  := TControl(Sender).Top  + (Pt.Y - ControlStartTop);

  Repaint;
end;

end.
